Index: lemon/glpk.cc
===================================================================
--- lemon/glpk.cc	(revision 576)
+++ lemon/glpk.cc	(revision 462)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2009
+ * Copyright (C) 2003-2008
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -32,5 +32,4 @@
     lp = glp_create_prob();
     glp_create_index(lp);
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -41,5 +40,4 @@
     rows = other.rows;
     cols = other.cols;
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -525,44 +523,18 @@
   }
 
-  void GlpkBase::freeEnv() {
-    glp_free_env();
-  }
-
-  void GlpkBase::_messageLevel(MessageLevel level) {
-    switch (level) {
-    case MESSAGE_NOTHING:
-      _message_level = GLP_MSG_OFF;
-      break;
-    case MESSAGE_ERROR:
-      _message_level = GLP_MSG_ERR;
-      break;
-    case MESSAGE_WARNING:
-      _message_level = GLP_MSG_ERR;
-      break;
-    case MESSAGE_NORMAL:
-      _message_level = GLP_MSG_ON;
-      break;
-    case MESSAGE_VERBOSE:
-      _message_level = GLP_MSG_ALL;
-      break;
-    }
-  }
-
-  GlpkBase::FreeEnvHelper GlpkBase::freeEnvHelper;
-
   // GlpkLp members
 
   GlpkLp::GlpkLp()
-    : LpBase(), LpSolver(), GlpkBase() {
-    presolver(false);
+    : LpBase(), GlpkBase(), LpSolver() {
+    messageLevel(MESSAGE_NO_OUTPUT);
   }
 
   GlpkLp::GlpkLp(const GlpkLp& other)
-    : LpBase(other), LpSolver(other), GlpkBase(other) {
-    presolver(false);
-  }
-
-  GlpkLp* GlpkLp::newSolver() const { return new GlpkLp; }
-  GlpkLp* GlpkLp::cloneSolver() const { return new GlpkLp(*this); }
+    : LpBase(other), GlpkBase(other), LpSolver(other) {
+    messageLevel(MESSAGE_NO_OUTPUT);
+  }
+
+  GlpkLp* GlpkLp::_newSolver() const { return new GlpkLp; }
+  GlpkLp* GlpkLp::_cloneSolver() const { return new GlpkLp(*this); }
 
   const char* GlpkLp::_solverName() const { return "GlpkLp"; }
@@ -583,24 +555,20 @@
     glp_init_smcp(&smcp);
 
-    smcp.msg_lev = _message_level;
-    smcp.presolve = _presolve;
-
-    // If the basis is not valid we get an error return value.
-    // In this case we can try to create a new basis.
-    switch (glp_simplex(lp, &smcp)) {
-    case 0:
-      break;
-    case GLP_EBADB:
-    case GLP_ESING:
-    case GLP_ECOND:
-      glp_term_out(false);
-      glp_adv_basis(lp, 0);
-      glp_term_out(true);
-      if (glp_simplex(lp, &smcp) != 0) return UNSOLVED;
-      break;
-    default:
-      return UNSOLVED;
-    }
-
+    switch (_message_level) {
+    case MESSAGE_NO_OUTPUT:
+      smcp.msg_lev = GLP_MSG_OFF;
+      break;
+    case MESSAGE_ERROR_MESSAGE:
+      smcp.msg_lev = GLP_MSG_ERR;
+      break;
+    case MESSAGE_NORMAL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ON;
+      break;
+    case MESSAGE_FULL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ALL;
+      break;
+    }
+
+    if (glp_simplex(lp, &smcp) != 0) return UNSOLVED;
     return SOLVED;
   }
@@ -612,24 +580,21 @@
     glp_init_smcp(&smcp);
 
-    smcp.msg_lev = _message_level;
+    switch (_message_level) {
+    case MESSAGE_NO_OUTPUT:
+      smcp.msg_lev = GLP_MSG_OFF;
+      break;
+    case MESSAGE_ERROR_MESSAGE:
+      smcp.msg_lev = GLP_MSG_ERR;
+      break;
+    case MESSAGE_NORMAL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ON;
+      break;
+    case MESSAGE_FULL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ALL;
+      break;
+    }
     smcp.meth = GLP_DUAL;
-    smcp.presolve = _presolve;
-
-    // If the basis is not valid we get an error return value.
-    // In this case we can try to create a new basis.
-    switch (glp_simplex(lp, &smcp)) {
-    case 0:
-      break;
-    case GLP_EBADB:
-    case GLP_ESING:
-    case GLP_ECOND:
-      glp_term_out(false);
-      glp_adv_basis(lp, 0);
-      glp_term_out(true);
-      if (glp_simplex(lp, &smcp) != 0) return UNSOLVED;
-      break;
-    default:
-      return UNSOLVED;
-    }
+
+    if (glp_simplex(lp, &smcp) != 0) return UNSOLVED;
     return SOLVED;
   }
@@ -849,6 +814,10 @@
   }
 
-  void GlpkLp::presolver(bool presolve) {
-    _presolve = presolve;
+  void GlpkLp::presolver(bool b) {
+    lpx_set_int_parm(lp, LPX_K_PRESOL, b ? 1 : 0);
+  }
+
+  void GlpkLp::messageLevel(MessageLevel m) {
+    _message_level = m;
   }
 
@@ -856,9 +825,11 @@
 
   GlpkMip::GlpkMip()
-    : LpBase(), MipSolver(), GlpkBase() {
+    : LpBase(), GlpkBase(), MipSolver() {
+    messageLevel(MESSAGE_NO_OUTPUT);
   }
 
   GlpkMip::GlpkMip(const GlpkMip& other)
-    : LpBase(), MipSolver(), GlpkBase(other) {
+    : LpBase(), GlpkBase(other), MipSolver() {
+    messageLevel(MESSAGE_NO_OUTPUT);
   }
 
@@ -889,24 +860,21 @@
     glp_init_smcp(&smcp);
 
-    smcp.msg_lev = _message_level;
+    switch (_message_level) {
+    case MESSAGE_NO_OUTPUT:
+      smcp.msg_lev = GLP_MSG_OFF;
+      break;
+    case MESSAGE_ERROR_MESSAGE:
+      smcp.msg_lev = GLP_MSG_ERR;
+      break;
+    case MESSAGE_NORMAL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ON;
+      break;
+    case MESSAGE_FULL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ALL;
+      break;
+    }
     smcp.meth = GLP_DUAL;
 
-    // If the basis is not valid we get an error return value.
-    // In this case we can try to create a new basis.
-    switch (glp_simplex(lp, &smcp)) {
-    case 0:
-      break;
-    case GLP_EBADB:
-    case GLP_ESING:
-    case GLP_ECOND:
-      glp_term_out(false);
-      glp_adv_basis(lp, 0);
-      glp_term_out(true);
-      if (glp_simplex(lp, &smcp) != 0) return UNSOLVED;
-      break;
-    default:
-      return UNSOLVED;
-    }
-
+    if (glp_simplex(lp, &smcp) != 0) return UNSOLVED;
     if (glp_get_status(lp) != GLP_OPT) return SOLVED;
 
@@ -914,5 +882,18 @@
     glp_init_iocp(&iocp);
 
-    iocp.msg_lev = _message_level;
+    switch (_message_level) {
+    case MESSAGE_NO_OUTPUT:
+      iocp.msg_lev = GLP_MSG_OFF;
+      break;
+    case MESSAGE_ERROR_MESSAGE:
+      iocp.msg_lev = GLP_MSG_ERR;
+      break;
+    case MESSAGE_NORMAL_OUTPUT:
+      iocp.msg_lev = GLP_MSG_ON;
+      break;
+    case MESSAGE_FULL_OUTPUT:
+      iocp.msg_lev = GLP_MSG_ALL;
+      break;
+    }
 
     if (glp_intopt(lp, &iocp) != 0) return UNSOLVED;
@@ -960,8 +941,12 @@
   }
 
-  GlpkMip* GlpkMip::newSolver() const { return new GlpkMip; }
-  GlpkMip* GlpkMip::cloneSolver() const {return new GlpkMip(*this); }
+  GlpkMip* GlpkMip::_newSolver() const { return new GlpkMip; }
+  GlpkMip* GlpkMip::_cloneSolver() const {return new GlpkMip(*this); }
 
   const char* GlpkMip::_solverName() const { return "GlpkMip"; }
 
+  void GlpkMip::messageLevel(MessageLevel m) {
+    _message_level = m;
+  }
+
 } //END OF NAMESPACE LEMON
Index: lemon/glpk.h
===================================================================
--- lemon/glpk.h	(revision 576)
+++ lemon/glpk.h	(revision 462)
@@ -101,22 +101,4 @@
     virtual void _clear();
 
-    virtual void _messageLevel(MessageLevel level);
-
-  private:
-
-    static void freeEnv();
-
-    struct FreeEnvHelper {
-      ~FreeEnvHelper() {
-        freeEnv();
-      }
-    };
-    
-    static FreeEnvHelper freeEnvHelper;
-
-  protected:
-    
-    int _message_level;
-    
   public:
 
@@ -138,5 +120,5 @@
   /// This class implements an interface for the GLPK LP solver.
   ///\ingroup lp_group
-  class GlpkLp : public LpSolver, public GlpkBase {
+  class GlpkLp : public GlpkBase, public LpSolver {
   public:
 
@@ -145,9 +127,4 @@
     ///\e
     GlpkLp(const GlpkLp&);
-
-    ///\e
-    virtual GlpkLp* cloneSolver() const;
-    ///\e
-    virtual GlpkLp* newSolver() const;
 
   private:
@@ -159,4 +136,7 @@
 
   protected:
+
+    virtual GlpkLp* _cloneSolver() const;
+    virtual GlpkLp* _newSolver() const;
 
     virtual const char* _solverName() const;
@@ -174,4 +154,6 @@
     virtual Value _getDualRay(int i) const;
 
+    ///\todo It should be clarified
+    ///
     virtual ProblemType _getPrimalType() const;
     virtual ProblemType _getDualType() const;
@@ -185,17 +167,35 @@
     SolveExitStatus solveDual();
 
+    ///Turns on or off the presolver
+
+    ///Turns on (\c b is \c true) or off (\c b is \c false) the presolver
+    ///
+    ///The presolver is off by default.
+    void presolver(bool b);
+
+    ///Enum for \c messageLevel() parameter
+    enum MessageLevel {
+      /// no output (default value)
+      MESSAGE_NO_OUTPUT = 0,
+      /// error messages only
+      MESSAGE_ERROR_MESSAGE = 1,
+      /// normal output
+      MESSAGE_NORMAL_OUTPUT = 2,
+      /// full output (includes informational messages)
+      MESSAGE_FULL_OUTPUT = 3
+    };
+
   private:
 
-    bool _presolve;
-
-  public:
-
-    ///Turns on or off the presolver
-
-    ///Turns on (\c b is \c true) or off (\c b is \c false) the presolver
-    ///
-    ///The presolver is off by default.
-    void presolver(bool presolve);
-
+    MessageLevel _message_level;
+
+  public:
+
+    ///Set the verbosity of the messages
+
+    ///Set the verbosity of the messages
+    ///
+    ///\param m is the level of the messages output by the solver routines.
+    void messageLevel(MessageLevel m);
   };
 
@@ -204,5 +204,5 @@
   /// This class implements an interface for the GLPK MIP solver.
   ///\ingroup lp_group
-  class GlpkMip : public MipSolver, public GlpkBase {
+  class GlpkMip : public GlpkBase, public MipSolver {
   public:
 
@@ -212,8 +212,8 @@
     GlpkMip(const GlpkMip&);
 
-    virtual GlpkMip* cloneSolver() const;
-    virtual GlpkMip* newSolver() const;
-
-  protected:
+  protected:
+
+    virtual GlpkMip* _cloneSolver() const;
+    virtual GlpkMip* _newSolver() const;
 
     virtual const char* _solverName() const;
@@ -227,4 +227,28 @@
     virtual Value _getSolValue() const;
 
+    ///Enum for \c messageLevel() parameter
+    enum MessageLevel {
+      /// no output (default value)
+      MESSAGE_NO_OUTPUT = 0,
+      /// error messages only
+      MESSAGE_ERROR_MESSAGE = 1,
+      /// normal output
+      MESSAGE_NORMAL_OUTPUT = 2,
+      /// full output (includes informational messages)
+      MESSAGE_FULL_OUTPUT = 3
+    };
+
+  private:
+
+    MessageLevel _message_level;
+
+  public:
+
+    ///Set the verbosity of the messages
+
+    ///Set the verbosity of the messages
+    ///
+    ///\param m is the level of the messages output by the solver routines.
+    void messageLevel(MessageLevel m);
   };
 
Index: lemon/graph_to_eps.h
===================================================================
--- lemon/graph_to_eps.h	(revision 584)
+++ lemon/graph_to_eps.h	(revision 515)
@@ -65,9 +65,9 @@
 ///Default traits class of \ref GraphToEps.
 ///
-///\param GR is the type of the underlying graph.
-template<class GR>
+///\c G is the type of the underlying graph.
+template<class G>
 struct DefaultGraphToEpsTraits
 {
-  typedef GR Graph;
+  typedef G Graph;
   typedef typename Graph::Node Node;
   typedef typename Graph::NodeIt NodeIt;
@@ -140,12 +140,13 @@
 
   ///Constructor
-  ///\param gr  Reference to the graph to be printed.
-  ///\param ost Reference to the output stream.
+  ///\param _g  Reference to the graph to be printed.
+  ///\param _os Reference to the output stream.
+  ///\param _os Reference to the output stream.
   ///By default it is <tt>std::cout</tt>.
-  ///\param pros If it is \c true, then the \c ostream referenced by \c os
+  ///\param _pros If it is \c true, then the \c ostream referenced by \c _os
   ///will be explicitly deallocated by the destructor.
-  DefaultGraphToEpsTraits(const GR &gr, std::ostream& ost = std::cout,
-                          bool pros = false) :
-    g(gr), os(ost),
+  DefaultGraphToEpsTraits(const G &_g,std::ostream& _os=std::cout,
+                          bool _pros=false) :
+    g(_g), os(_os),
     _coords(dim2::Point<double>(1,1)), _nodeSizes(1), _nodeShapes(0),
     _nodeColors(WHITE), _arcColors(BLACK),
@@ -158,6 +159,6 @@
     _showNodeText(false), _nodeTexts(false), _nodeTextSize(1),
     _showNodePsText(false), _nodePsTexts(false), _nodePsTextsPreamble(0),
-    _undirected(lemon::UndirectedTagIndicator<GR>::value),
-    _pleaseRemoveOsStream(pros), _scaleToA4(false),
+    _undirected(lemon::UndirectedTagIndicator<G>::value),
+    _pleaseRemoveOsStream(_pros), _scaleToA4(false),
     _nodeTextColorType(SAME_COL), _nodeTextColors(BLACK),
     _autoNodeScale(false),
@@ -269,16 +270,20 @@
     ///\image html nodeshape_1.png
     ///\image latex nodeshape_1.eps "SQUARE shape (1)" width=2cm
+    ///
     SQUARE=1,
     /// = 2
     ///\image html nodeshape_2.png
     ///\image latex nodeshape_2.eps "DIAMOND shape (2)" width=2cm
+    ///
     DIAMOND=2,
     /// = 3
     ///\image html nodeshape_3.png
-    ///\image latex nodeshape_3.eps "MALE shape (3)" width=2cm
+    ///\image latex nodeshape_2.eps "MALE shape (4)" width=2cm
+    ///
     MALE=3,
     /// = 4
     ///\image html nodeshape_4.png
-    ///\image latex nodeshape_4.eps "FEMALE shape (4)" width=2cm
+    ///\image latex nodeshape_2.eps "FEMALE shape (4)" width=2cm
+    ///
     FEMALE=4
   };
@@ -1130,11 +1135,11 @@
 ///to the end of the parameter list.
 ///\sa GraphToEps
-///\sa graphToEps(GR &g, const char *file_name)
-template<class GR>
-GraphToEps<DefaultGraphToEpsTraits<GR> >
-graphToEps(GR &g, std::ostream& os=std::cout)
+///\sa graphToEps(G &g, const char *file_name)
+template<class G>
+GraphToEps<DefaultGraphToEpsTraits<G> >
+graphToEps(G &g, std::ostream& os=std::cout)
 {
   return
-    GraphToEps<DefaultGraphToEpsTraits<GR> >(DefaultGraphToEpsTraits<GR>(g,os));
+    GraphToEps<DefaultGraphToEpsTraits<G> >(DefaultGraphToEpsTraits<G>(g,os));
 }
 
@@ -1143,11 +1148,11 @@
 ///\ingroup eps_io
 ///This function does the same as
-///\ref graphToEps(GR &g,std::ostream& os)
+///\ref graphToEps(G &g,std::ostream& os)
 ///but it writes its output into the file \c file_name
 ///instead of a stream.
-///\sa graphToEps(GR &g, std::ostream& os)
-template<class GR>
-GraphToEps<DefaultGraphToEpsTraits<GR> >
-graphToEps(GR &g,const char *file_name)
+///\sa graphToEps(G &g, std::ostream& os)
+template<class G>
+GraphToEps<DefaultGraphToEpsTraits<G> >
+graphToEps(G &g,const char *file_name)
 {
   std::ostream* os = new std::ofstream(file_name);
@@ -1156,6 +1161,6 @@
     throw IoError("Cannot write file", file_name);
   }
-  return GraphToEps<DefaultGraphToEpsTraits<GR> >
-    (DefaultGraphToEpsTraits<GR>(g,*os,true));
+  return GraphToEps<DefaultGraphToEpsTraits<G> >
+    (DefaultGraphToEpsTraits<G>(g,*os,true));
 }
 
@@ -1164,11 +1169,11 @@
 ///\ingroup eps_io
 ///This function does the same as
-///\ref graphToEps(GR &g,std::ostream& os)
+///\ref graphToEps(G &g,std::ostream& os)
 ///but it writes its output into the file \c file_name
 ///instead of a stream.
-///\sa graphToEps(GR &g, std::ostream& os)
-template<class GR>
-GraphToEps<DefaultGraphToEpsTraits<GR> >
-graphToEps(GR &g,const std::string& file_name)
+///\sa graphToEps(G &g, std::ostream& os)
+template<class G>
+GraphToEps<DefaultGraphToEpsTraits<G> >
+graphToEps(G &g,const std::string& file_name)
 {
   std::ostream* os = new std::ofstream(file_name.c_str());
@@ -1177,6 +1182,6 @@
     throw IoError("Cannot write file", file_name);
   }
-  return GraphToEps<DefaultGraphToEpsTraits<GR> >
-    (DefaultGraphToEpsTraits<GR>(g,*os,true));
+  return GraphToEps<DefaultGraphToEpsTraits<G> >
+    (DefaultGraphToEpsTraits<G>(g,*os,true));
 }
 
Index: lemon/grid_graph.h
===================================================================
--- lemon/grid_graph.h	(revision 582)
+++ lemon/grid_graph.h	(revision 440)
@@ -497,6 +497,8 @@
   ///\endcode
   ///
-  /// This graph type fully conforms to the \ref concepts::Graph
-  /// "Graph concept".
+  /// This graph type is fully conform to the \ref concepts::Graph
+  /// "Graph" concept, and it also has an important extra feature
+  /// that its maps are real \ref concepts::ReferenceMap
+  /// "reference map"s.
   class GridGraph : public ExtendedGridGraphBase {
   public:
